// PAGEVCTRL.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "PAGEVCTRL.h"
#include "Susi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BYTE minimum = 0;
BYTE maximum = 0;
BYTE stepping = 0;


/////////////////////////////////////////////////////////////////////////////
// CPAGEVCTRL property page

IMPLEMENT_DYNCREATE(CPAGEVCTRL, CPropertyPage)

CPAGEVCTRL::CPAGEVCTRL() : CPropertyPage(CPAGEVCTRL::IDD)
{
	//{{AFX_DATA_INIT(CPAGEVCTRL)
	m_BRIGHTVAL = 0;
	m_RAD_VGASwitch = 0;
	//}}AFX_DATA_INIT
}

CPAGEVCTRL::~CPAGEVCTRL()
{
}

void CPAGEVCTRL::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPAGEVCTRL)
	DDX_Control(pDX, IDC_BRIGUP, m_BRIGHTUP);
	DDX_Control(pDX, IDC_BRIGSLIDER, m_BRIGSLIDER_CTRL);
	DDX_Control(pDX, IDC_BRIGDOWN, m_BRIGDOWN);
	DDX_Text(pDX, IDC_BRIGVAL, m_BRIGHTVAL);
	DDX_Radio(pDX, IDC_RAD_VGAON, m_RAD_VGASwitch);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPAGEVCTRL, CPropertyPage)
	//{{AFX_MSG_MAP(CPAGEVCTRL)
	ON_BN_CLICKED(IDC_RAD_VGAON, OnRadVgaon)
	ON_BN_CLICKED(IDC_RAD_VGAOFF, OnRadVgaoff)
	ON_BN_CLICKED(IDC_BRIGUP, OnBrigup)
	ON_BN_CLICKED(IDC_BRIGDOWN, OnBrigdown)
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPAGEVCTRL message handlers

void CPAGEVCTRL::OnRadVgaon() 
{
	// TODO: Add your control notification handler code here
	if(SusiVCScreenOn()<0)
		AfxMessageBox(_T("Cannot turn on the screen!"));

	m_RAD_VGASwitch = 0;	
}

void CPAGEVCTRL::OnRadVgaoff() 
{
	// TODO: Add your control notification handler code here
	if(SusiVCScreenOff()<0)
		AfxMessageBox(_T("Cannot turn off the screen!"));

	m_RAD_VGASwitch = 1;
	
}

void CPAGEVCTRL::OnBrigup() 
{
	// TODO: Add your control notification handler code here
	BYTE Status = 0;
	UpdateData(TRUE);

	if(SusiVCGetBright(&Status) < 0)
		AfxMessageBox(_T("SusiVCGetBright function failed!"));

	else if(Status >= maximum)
		AfxMessageBox(_T("It is brightest."));

	else if(SusiVCSetBright(Status + (BYTE)stepping) < 0)
		AfxMessageBox(_T("SusiVCSetBright function failed!"));
	
	else{
		m_BRIGHTVAL = Status + (BYTE)stepping;
		//m_BRIGSLIDER_VAL = max - m_BRIGHTVAL;
		m_BRIGSLIDER_CTRL.SetPos(maximum - m_BRIGHTVAL);
	}

	UpdateData(FALSE);
	
}

void CPAGEVCTRL::OnBrigdown() 
{
	// TODO: Add your control notification handler code here
	BYTE Status = 0;
	UpdateData(TRUE);

	if(SusiVCGetBright(&Status) < 0)
		AfxMessageBox(_T("SusiVCGetBright function failed!"));

	else if(Status <= minimum)
		AfxMessageBox(_T("It is the darkest!"));

	else if(SusiVCSetBright(Status - (BYTE)stepping) < 0)
		AfxMessageBox(_T("SusiVCSetBright function failed!"));
	
	else{
		m_BRIGHTVAL = Status - (BYTE)stepping;
		//m_BRIGSLIDER_VAL = max - m_BRIGHTVAL;
		m_BRIGSLIDER_CTRL.SetPos(maximum - m_BRIGHTVAL);
	}

	UpdateData(FALSE);
	
}

void CPAGEVCTRL::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
		// TODO: Add your message handler code here and/or call default
	
	/*
	BYTE temp;
	
	UpdateData(TRUE);
	temp = maximum - m_BRIGSLIDER_CTRL.GetPos();
	
	if(temp < minimum)
	{
		AfxMessageBox(_T("It is darkest!"));
		m_BRIGHTVAL = minimum;
	}else if(temp >= maximum){
	    AfxMessageBox(_T("It is brightest!"));
	    m_BRIGHTVAL = maximum;
	    m_BRIGSLIDER_CTRL.SetPos(minimum);
	}else if(SusiVCSetBright(temp)<0){
        AfxMessageBox(_T("SusiVCSetBright function failed!"));
	}else{
		m_BRIGHTVAL = temp;
	}

	UpdateData(FALSE);
	*/
	
	UpdateData(TRUE);
	//m_BRIGHTVAL = 255 - m_BRIGSLIDER_VAL;
	m_BRIGHTVAL = maximum - m_BRIGSLIDER_CTRL.GetPos();
	UpdateData(FALSE);
	
	if(SusiVCSetBright(m_BRIGHTVAL)<0)
		AfxMessageBox(_T("SusiVCSetBright function failed!"));

	CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
}

BOOL CPAGEVCTRL::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch(pMsg->message)
	{
		case WM_KEYDOWN:
			switch (pMsg->wParam) 
			{
				case VK_F11: //Press F11 is to turn on the screen"
					if(SusiVCScreenOn()<0)
						AfxMessageBox(_T("Cannot turn on the screen!"));
					m_RAD_VGASwitch = 0;
					break;
				case VK_F12: //Press F12 to turn off the screen"

					if(SusiVCScreenOff()<0)
						AfxMessageBox(_T("Cannot turn off the screen!"));
					m_RAD_VGASwitch = 1;
					break;
				default:
					break;
			}
			break;
		default:
			break;

	}
	UpdateData(FALSE);
	return CPropertyPage::PreTranslateMessage(pMsg);
}

BOOL CPAGEVCTRL::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	BYTE Status;
	// TODO: Add extra initialization here
	SusiVCGetBrightRange(&minimum,&maximum,&stepping);
	SusiVCGetBright(&Status);
	m_BRIGSLIDER_CTRL.SetRange(minimum,maximum);
	m_BRIGSLIDER_CTRL.SetPos(Status);
	m_BRIGHTVAL = maximum - m_BRIGSLIDER_CTRL.GetPos();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
