/*++

Copyright (c) Advantech Co., Ltd. All Rights Reserved


File Name:
	PAGEIIC.cpp

Abstract:
	Implementation file for tab page IIC
	

Revision History:
---------------------------------------------
	May 18, 2006	Change to Susi v1.0

---------------------------------------------
	June 22, 2005	First release
	
---------------------------------------------

Programmers:
	Baker  Chang

--*/

#include "stdafx.h"
#include "SusiDEMO.h"
#include "PAGEIIC.h"
#include "Susi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPAGEIIC property page

IMPLEMENT_DYNCREATE(CPAGEIIC, CPropertyPage)

CPAGEIIC::CPAGEIIC() : CPropertyPage(CPAGEIIC::IDD)
{
	//{{AFX_DATA_INIT(CPAGEIIC)
	m_REGOFFSET = _T("0x0");
	m_RESULT = _T("0x0");
	m_SADDR = _T("0x0");
	//}}AFX_DATA_INIT
}

CPAGEIIC::~CPAGEIIC()
{
}

void CPAGEIIC::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPAGEIIC)
	DDX_Control(pDX, IDC_WRITEBYTE, m_WrBYTE);
	DDX_Control(pDX, IDC_READBYTE, m_RdBYTE);
	DDX_Text(pDX, IDC_REGOFFSET, m_REGOFFSET);
	DDX_Text(pDX, IDC_RESULT, m_RESULT);
	DDX_Text(pDX, IDC_SADDR, m_SADDR);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPAGEIIC, CPropertyPage)
	//{{AFX_MSG_MAP(CPAGEIIC)
	ON_BN_CLICKED(IDC_READBYTE, OnReadbyte)
	ON_BN_CLICKED(IDC_WRITEBYTE, OnWritebyte)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPAGEIIC message handlers

void CPAGEIIC::OnReadbyte() 
{
	// TODO: Add your control notification handler code here

	BYTE Address, Register, Result=0;
	char *p;
	UpdateData(TRUE);
	m_RESULT = _T("");

	Address = (BYTE)strtol(m_SADDR, &p, 16);
	Register = (BYTE)strtol(m_REGOFFSET, &p, 16);
	
	if(!SusiIICReadByte(Address, Register, &Result)){
		AfxMessageBox(_T("IIC Read Byte failed"));
	
	}else{
		
		TCHAR temp[3];
		CString output;

		_itot(Result, temp, 16);
		output = _T("0x");
		output.Insert(output.GetLength(), temp);
		m_RESULT = m_RESULT + output;

		UpdateData(FALSE);
	}
	
}

void CPAGEIIC::OnWritebyte() 
{
	// TODO: Add your control notification handler code here

	BYTE Address, Register, Result;
	char *p;
	UpdateData(TRUE);

	Address = (BYTE)strtol(m_SADDR, &p, 16);
	Register = (BYTE)strtol(m_REGOFFSET, &p, 16);
	Result = (BYTE)strtol(m_RESULT, &p, 16);

	// Write data to the device through IIC
	if(!SusiIICAvailable())
	{
		AfxMessageBox(_T("This platform don't support IIC Write Byte"));
	}
	else if(!SusiIICWriteByte(Address, Register, Result))
	{
		AfxMessageBox(_T("IIC Write Byte failed"));
	}
}

void CPAGEIIC::OnOK() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(!SusiUnInit())
		AfxMessageBox(_T("Susi uninitialize failed !"));

	CPropertyPage::OnOK();
}

void CPAGEIIC::OnCancel() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(!SusiUnInit())
		AfxMessageBox(_T("Susi uninitialize failed !"));

	CPropertyPage::OnCancel();
}
