/*++

Copyright (c) Advantech Co., Ltd. All Rights Reserved


File Name:
	SetPage.h

Abstract:
	Header file for Adding tab page
	

Revision History:
---------------------------------------------
	May 18, 2006	Change to Susi v1.0

---------------------------------------------
	June 22, 2005	First release
	
---------------------------------------------

Programmers:
	Baker  Chang

--*/

/////////////////////////////////////////////////////////////////////////////
// CSusiFuncSheet

#include "PAGEABOUT.h"
#include "PAGEWDT.h"
#include "PAGEGPIO.h"
#include "PAGESMBUS.h"
#include "PAGEIIC.h"
#include "PAGEMultiIIC.h"
#include "PAGEVCTRL.h"
#include "PAGEHWMNEW.h"


class CSusiFuncSheet : public CPropertySheet
{
	DECLARE_DYNAMIC(CSusiFuncSheet)

// Construction
public:
	CSusiFuncSheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CSusiFuncSheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

protected:
	void AddControlPages(void);

// Attributes
public:

	CPAGEABOUT		m_pageABOUT;
	CPAGEWDT		m_pageWDT;
	CPAGEGPIO		m_pageGPIO;
	CPAGESMBUS		m_pageSMBus;
	CPAGEIIC		m_pageIIC;
	CPAGEMultiIIC	m_pageMultiIIC;
	CPAGEVCTRL		m_pageVCTRL;
	CPAGEHWMNEW		m_pageHWMNEW;
	

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSusiFuncSheet)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSusiFuncSheet();
	virtual BOOL OnInitDialog();
	void PressButton( int nButton );
	BOOL PreTranslateMessage(MSG* pMsg);

	// Generated message map functions
protected:

	HICON m_hIcon;

	//{{AFX_MSG(CSusiFuncSheet)
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
