/*++

Copyright (c) Advantech Co., Ltd. All Rights Reserved


File Name:
	SusiDEMO.cpp

Abstract:
	Defines the class behaviors for the application.
	

Revision History:
---------------------------------------------
	May 16, 2006	Change to Susi v1.0

---------------------------------------------
	June 22, 2005	First release
	
---------------------------------------------

Programmers:
	Baker  Chang
	Victor Wu


--*/

#include "stdafx.h"
#include "SusiDEMO.h"
#include "Susi.h"
#include "SetPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSusiDEMOApp

BEGIN_MESSAGE_MAP(CSusiDEMOApp, CWinApp)
	//{{AFX_MSG_MAP(CSusiDEMOApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSusiDEMOApp construction

CSusiDEMOApp::CSusiDEMOApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSusiDEMOApp object

CSusiDEMOApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSusiDEMOApp initialization

BOOL CSusiDEMOApp::InitInstance()
{
	AfxEnableControlContainer();
	int nRet;
	// Standard initialization
	
	if((nRet=SusiInit())== 0)
	{
		// Get platform name and BIOS version
		BYTE size = SusiGetPlatformName(NULL,0);
		if(!size) size = 7; // For "Unknown"
		TCHAR *platform = new TCHAR[size];
		if(SusiGetPlatformName(platform,size)!=0)
			strcpy(platform, "Unknown");

		
		size = SusiGetBIOSVersion(NULL,0);
		if(!size) size = 7; // For "Unknown"
		TCHAR *BIOS = new TCHAR[size];
		if(SusiGetBIOSVersion(BIOS,size)!=0)
			strcpy(BIOS, "Unknown");

		TCHAR *ShowBIOSInfo = new TCHAR[100];
		strcpy( ShowBIOSInfo, "Platform Name:" );
		strcat( ShowBIOSInfo, platform );
		strcat( ShowBIOSInfo, "  BIOS Ver:" );
		strcat( ShowBIOSInfo, BIOS );
		
		// Create the page controller
		CSusiFuncSheet allcontrolssheet(ShowBIOSInfo);
		m_pMainWnd = &allcontrolssheet;
		allcontrolssheet.DoModal();
		AfxMessageBox(ShowBIOSInfo);

		delete []platform;
		delete []BIOS;
		delete []ShowBIOSInfo;
		
	}
	else
	{
		CString text;
		text.Format(_T("Susi initialize failed: %d\n"), nRet);
		AfxMessageBox(text);
		CSusiFuncSheet allcontrolssheet(_T("Susi Demo Application"));
		m_pMainWnd = &allcontrolssheet;
		allcontrolssheet.DoModal();
		AfxMessageBox(_T("Susi initialize failed2 !"));
	}

	
	return FALSE;
}
